/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

var urlLink = "http://www.ccc-mannheim.de/roomstate/state.xml";
var _updateTimeS = 1;
var intervalHandler;

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    window.clearInterval(intervalHandler);
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    checkConnectivity();
    window.clearInterval(intervalHandler);
    intervalHandler = window.setInterval(checkConnectivity, _updateTimeS * 1000);
    
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}

function $(id) 
{
	return document.getElementById(id);
}

function GetRandom( min, max ) 
{
	if( min > max ) {
	return( -1 );
	}
	if( min == max ) {
	return( min );
	}
	return min + parseInt( Math.random() * ( max-min+1 ));
}

function ShowOpen()
{
    $('stateOpen').innerText = "OPEN";
}

function ShowClosed()
{
    $('stateOpen').innerText = "CLOSED";
}

function ShowFailed()
{
    $('stateOpen').innerText = "FAIL";
}

function ShowOffline()
{
    $('stateOpen').innerText = "OFFLINE";
}

function ShowUndefined()
{
    $('stateOpen').innerText = "UNDEFINED";
}

function ShowTemperature(innenTemp, aussenTemp){
     $('innenTemp').innerText = innenTemp + " C";
     $('aussenTemp').innerText = aussenTemp + " C";
}

function ShowDoor(door){
    $('door').innerText = door;
}

function ShowTimestamp(time_1){
    //$('timestamp').innerText = time_1;
    var Zeit = new Date();
    Zeit.setTime (time_1 * 1000);
    a = Zeit;
    b = a.getHours();
    c = a.getMinutes();
    d = a.getSeconds();
    e = a.getFullYear();
    f = a.getMonth() + 1;
    g = a.getDate();
    zeit = b+':'+c+':'+d+' '+g+'-'+f+'-'+e;
    $('timestamp').innerText = zeit;
}

function checkConnectivity() 
{
    alert("checkConnectivity");
  try
  { 
	 xmlhttp=new XMLHttpRequest();
	 requestLink = urlLink + "?" + GetRandom(0,5000000000);
	 requestLink = requestLink + "&" + GetRandom(0,7000000000);
	 requestLink = requestLink + "&" + GetRandom(0,6000000000);		
     xmlhttp.open('GET', requestLink, true);		
	 xmlhttp.onreadystatechange = function () {		
		if (xmlhttp.readyState  == 4) 
		{				
			//var responseWords = xmlhttp.responseText.split(" ");
			if(xmlhttp.status == 200){
			    //die xml antwort auswerten
			    evaluateStateXML(xmlhttp.responseXML);			    			   			 				
			}
			else
			{
				    ShowOffline();
			}
		}
	};
	xmlhttp.send(null);
  }catch(e){
	alert(e);
  }
}

function evaluateStateXML(xml)
{
    try{
        var status = xml.getElementsByTagName("status")[0].firstChild.nodeValue;
        if(status == "OPEN"){
            ShowOpen();
        }
        else if(status == "CLOSED"){
            ShowClosed();
        }
        else{
            ShowUndefined();
        }
    }catch(e){
        ShowUndefined();
    }
    
    try{       
        var innenTemp = xml.getElementsByTagName("innen")[0].firstChild.nodeValue;
        var aussenTemp = xml.getElementsByTagName("aussen")[0].firstChild.nodeValue;
        ShowTemperature(innenTemp, aussenTemp);
    }catch(e){  
        ShowTemperature("UNDEFINED", "UNDEFINED");  
    }
    
    try{
        var door = xml.getElementsByTagName("door")[0].firstChild.nodeValue;
        if (door == 1){
            door_s = "LOCKED"
        } else if(door == 0) {
            door_s = "UNLOCKED"
        } else {
            door_s = "UNDEFINED"
        }
        ShowDoor(door_s);
    }catch(e){
        ShowDoor("OFFLINE");
    }
    
    try{
        var timestamp_1 = xml.getElementsByTagName("timestamp")[0].firstChild.nodeValue;
        ShowTimestamp(timestamp_1);
    }catch(e){
        ShowTimestamp("OFFLINE");
    }
    
}

function updatewert()
{
    updateTimeS = textField.value
}